<template>
  <div>
    <div v-if="this.percentageImo === 100">
      <div class="breadcrumb mb-4">
        <span style="cursor: pointer" @click="$router.push({ name: 'home' })"
          >Inicio</span
        >
        <span class="ml-4">></span>
        <span class="ml-4" style="color: #999999"
          >Encuesta Índice de Madurez Organizacional</span
        >
      </div>
      <v-row>
        <v-col md="4">
          <imo-summary
            :imo-result="Math.round(getIndexInfo.indexScore.score)"
            :dimensions="getIndexInfo.indexScore.dimensionScores"
            :maturity-level="getIndexInfo.imoLevelName"
            :maturity-level-text="getGeneralComment"
          />
        </v-col>
        <v-col md="8">
          <v-row>
            <v-col>
              <imo-results
                :most-critical-chain="getDimensionAdvices.CadenaDeValor"
                :most-critical-ecosistem="getDimensionAdvices.Ecosistema"
                :chain-subdimension="subdimensions"
                :ecosistem-subdimension="subdimensionsE"
              />
            </v-col>
          </v-row>
          <v-row>
            <v-col>
              <imo-recomendations
                :subdimension-recomendation="
                  getDimensionAdvices.CadenaDeValor.mostCriticalVsOthers
                "
                :redirect="
                  getIndexInfo.imoLevelName === 'Preparada'
                    ? this.percentage !== 100
                      ? '/dti-form'
                      : '/plans'
                    : '/capacitaciones'
                "
                :recomendation="getGeneralAdvice"
                :maturity-level="getIndexInfo.imoLevelName"
              />
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </div>
    <div v-else>
      <div
        v-if="loading"
        class="d-flex justify-center align-center flex-column"
        style="height: 100%"
      >
        <v-progress-circular
          indeterminate
          class="d-block text-center"
          color="#7319D5"
          size="60"
          width="6"
        />
      </div>
    </div>
    <div v-if="error">
      <h1 style="text-align: center">Algo salio mal</h1>
    </div>
  </div>
</template>

<script>
import IMOSummary from "@/components/dashboard/IMOSummary.vue";
import IMORecomendations from "@/components/dashboard/IMORecomendations.vue";
import IMOResultsByDimension from "@/components/dashboard/IMOResultsByDimension.vue";
import { mapGetters, mapActions } from "vuex";

export default {
  components: {
    "imo-summary": IMOSummary,
    "imo-recomendations": IMORecomendations,
    "imo-results": IMOResultsByDimension,
  },
  data() {
    return {
      subdimensions: [],
      subdimensionsE: [],
      userId: localStorage.getItem("userId"),
      loading: true,
      error: false,
    };
  },
  async created() {
    this.init();
    await this.surveyComplete(this.userId);
    if (this.percentageImo !== 100) {
      this.$router.replace("/survey-imo");
    }
    if (this.percentageImo === 100) {
      await this.getRecomendations()
        .then(() => {
          console.log("ok");
        })
        .catch(() => {
          this.error = true;
          setTimeout(() => {
            this.$router.replace("/home");
          }, 2000);
        });

      this.subdimensions =
        this.getIndexInfo.indexScore.dimensionScores[1].subdimensionScores;
      this.subdimensionsE =
        this.getIndexInfo.indexScore.dimensionScores[0].subdimensionScores;
    }
  },
  computed: {
    ...mapGetters("ImoStore", [
      "getDimensionAdvices",
      "getGeneralAdvice",
      "getGeneralComment",
      "getIndexInfo",
    ]),
    ...mapGetters("DigitalTransformationStore", [
      "percentage",
      "percentageImo",
    ]),
  },
  methods: {
    ...mapActions("ImoStore", ["getRecomendations", "init"]),
    ...mapActions("DigitalTransformationStore", ["surveyComplete"]),
  },
};
</script>

<style scoped>
.breadcrumb {
  font-size: 16px;
  font-family: Roboto Condensed;
  color: #7319d5;
}
</style>
